<?php
/*
Users Online FlatFile by Drew Phillips
http://www.neoprogrammers.com
Copyright 2004 Drew Phillips
Distribute Freely as long as this copyright remains unchanged.

***Setup***
Depending on your webserver setup, you may first need to create the
file data.txt and set proper write permissions to it, however in most 
cases it should be created the first time this program runs.
set the sessionTime variable equal to the number of minutes you wish to 
keep a user "online".
For example, if set to 10 minutes, an old visitor wont be deleted unless their
last recorded visit was greater than 10 minutes ago.


***Usage***
This script will only output the current number of visitors therefore
you can use any html tags and words around the include call to customize 
the appearance and give a truly unique and fully integrated look.  To display
the count and update the current table of online users, use the following php:
<?php include("/path/to/online.php"); ?>
If you wish to include this on many pages, however, not display 
the count on some, you can do this to surpress the output of the number:
<?php $uo_keepquiet = TRUE; include("/path/to/onlinesql.php"); ?>

/*

//set the two variables below

$dataFile = "/home/username/public_html/online/data.txt";

$sessionTime = 5; //time in **minutes** to consider someone online before removing them

#####################################################
# No editing needed below
#####################################################

error_reporting(E_ERROR | E_PARSE);

if(!file_exists($dataFile)) {
	$fp = fopen($dataFile, "w+");
	fclose($fp);
}

$ip = $_SERVER['REMOTE_ADDR'];
$users = array();
$onusers = array();

//get users part
$fp = fopen($dataFile, "r");
flock($fp, LOCK_SH);
while(!feof($fp)) {
	$users[] = rtrim(fgets($fp, 32));
}
flock($fp, LOCK_UN);
fclose($fp);


//cleanup part
$x = 0;
$alreadyIn = FALSE;
foreach($users as $key => $data) {
	list( , $lastvisit) = explode("|", $data);
	if(time() - $lastvisit >= $sessionTime * 60) {
		$users[$x] = "";
	} else {
		if(strpos($data, $ip) !== FALSE) {
			$alreadyIn = TRUE;
			$users[$x] = "$ip|" . time(); //update record
		}
	}
	$x++;
}

if($alreadyIn == FALSE) {
	$users[] = "$ip|" . time();
}

//write file
$fp = fopen($dataFile, "w+");
flock($fp, LOCK_EX);
$i = 0;
foreach($users as $single) {
	if($single != "") {
		fwrite($fp, $single . "\r\n");
		$i++;
	}
}
flock($fp, LOCK_UN);
fclose($fp);

if($uo_keepquiet != TRUE) {
	echo $i;
}

?>

